<?php
namespace Financeiro\Repositories;

use Setforms2\Shared\ORM\DateTime;

/**
 * Class Sdoccorr
 * @package Financeiro\Repositories
 */
class Sdoccorr extends \Doctrine\ORM\EntityRepository
{
    /**
     * @param $nrorg
     * @param $cdreducont
     * @param DateTime $data
     * @return mixed
     * @throws \Exception
     */
    public function getSaldoAnterior($nrorg, $cdreducont, $data){
        try{
            $sql = <<<SQL
            SELECT VRSDOCCORR
            FROM SDOCCORR
            WHERE CDREDUCONT = :P_CDREDUCONT  AND
                  NRORG = :P_NRORG AND
                  DTSDOCCORR = (SELECT MAX(DTSDOCCORR)
                                FROM SDOCCORR
                                WHERE CDREDUCONT = :P_CDREDUCONT AND
                                      DTSDOCCORR <= :P_DATA)
SQL;

            if($data instanceof Datetime)
                $data = $data->format('d/m/Y');

            $params = array(
                'P_NRORG' => $nrorg,
                'P_CDREDUCONT' => $cdreducont,
                'P_DATA' => $data,

            );

            return self::getEntityManager()->getConnection()->fetchColumn($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }

    }

    public function getSaldoPeriodo($nrorg, $cdreducont, $dtsdoccorr){
        $sql = <<<SQL
                SELECT *
                  FROM SDOCCORR
                 WHERE
                  (CDREDUCONT =  :P_CDREDUCONT) AND
                  (DTSDOCCORR >= :P_DTSDOCCORR) AND
                  (NRORG      =  :P_NRORG)
                ORDER BY DTSDOCCORR
SQL;
        $params = array(
            'P_NRORG' => $nrorg,
            'P_CDREDUCONT' => $cdreducont,
            'P_DTSDOCCORR' => $dtsdoccorr
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);

    }

}